//+------------------------------------------------------------------+
//|                                                         OBV2.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DodgerBlue
#property indicator_color2  Gray
#property indicator_color3  Gray
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int    BandPeriod         = 20;
extern double BandMultiplier     = 1.00;

extern bool   arrowsVisible      = true;
extern string arrowsIdentifier   = "obv arrows1";
extern double arrowsDisplacement = 1.5;
extern color  arrowsUpColor      = LimeGreen;
extern color  arrowsDnColor      = Red;

//
//
//
//

double obv[];
double bandUp[];
double bandDn[];
double trend[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(4); 
   SetIndexBuffer(0,obv);
   SetIndexBuffer(1,bandUp);
   SetIndexBuffer(2,bandDn);
   SetIndexBuffer(3,trend);
   SetIndexLabel(0,"obv");
   SetIndexLabel(1,"bUp");
   SetIndexLabel(2,"bDn");
   SetIndexLabel(3,"obv-trd");
   
IndicatorShortName("obv2 bands");
return(0);
}

//
//
//
//
//

int deinit()
{
   
   if (arrowsVisible) deleteArrows();
      
   return(0); 
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      if (i==(Bars-1))                                                                     { obv[i] = Volume[i]; }
      else  { if((High[i] == Low[i]) || (Open[i] == Close[i]) || (Close[i] == Close[i+1])) { obv[i] = obv[i+1];  }
      
      else  { if (Close[i] > Open[i])   
                   obv[i] = obv[i+1] + (Volume[i] * (Close[i] - Open[i]) / (High[i] - Low[i]));
              else obv[i] = obv[i+1] - (Volume[i] * (Open[i] - Close[i]) / (High[i] - Low[i])); } }
   }
   for (i=limit; i>=0; i--)
   {
      double ma = iMAOnArray(obv,0,BandPeriod,0,MODE_SMA,i);
      bandUp[i] = ma+iATR(NULL,0,BandPeriod,i)*BandMultiplier;
      bandDn[i] = ma-iATR(NULL,0,BandPeriod,i)*BandMultiplier;
      trend[i] = trend[i+1];
         if (obv[i] < bandDn[i]) trend[i] =-1;
         if (obv[i] > bandUp[i]) trend[i] = 1; 
         manageArrow(i);            
   }
return( 0 );
}

//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
  
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
    string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//


